import pygame, sys,os, random
import math

import GameController

reload( GameController )

'''

Must make tool to spit out arc that is animated in a circle to simple verify that timing and stuff work

Plus I'll be abel to get real performance numbers

'''
info = "test"
from pygame.locals import *
pygame.init()

window = pygame.display.set_mode((512,512))
pygame.display.set_caption("Amytis's Ascension")


pygame.joystick.init() # main joystick device system

useJoystick = False
'''
controller = None
try:
	controller = pygame.joystick.Joystick(0) # create a joystick instance
	controller.init() # init instance
	print 'Enabled joystick: ' + controller.get_name()
except pygame.error:
	print 'no joystick found.'
    '''




def loadImage( filename, colorKey=True ):

    img = pygame.image.load(filename).convert()
    if colorKey:
        colorkey = img.get_at((0,0))
        img.set_colorkey(colorkey, RLEACCEL )

    return img

def loadImage2( filename, colorKey ):

    img = pygame.image.load(filename).convert()

    colorkey = img.get_at( colorKey )
    img.set_colorkey(colorkey, RLEACCEL )

    return img

bugImage = loadImage( "art/bug.png")

mound = loadImage( "art/mound.png")

spiderWalk = [ loadImage( "art/spider01.png"),
loadImage( "art/spider02.png"),
loadImage( "art/spider03.png"),
loadImage( "art/spider04.png"),
]

class Living( pygame.sprite.Sprite ):
    def __init__( self, health, fps, pos, persistent=False ):
        pygame.sprite.Sprite.__init__(self)
        self.health =  health

        self._start = pygame.time.get_ticks()
        self._delay = 1000 / fps
        self._last_update = 0
        self._frame = 0

        self.pos = pos

        if persistent:
            self.deathClock = -100
        else:
            self.deathClock = 0


    def Tick(self, t):
        # Note that this doesn't work if it's been more that self._delay
        # time between calls to update(); we only update the image once
        # then, but it really should be updated twice.

        if t - self._last_update > self._delay:
            self._frame += 1
            if self._frame >= len(self._images): self._frame = 0
            self.image = self._images[self._frame]
            self._last_update = t
            return True

        # Kill the sprite if offscreen for 1 second
        if self.deathClock >= 0:
            if abs( self.pos[0] - camera.x ) > 550  or abs( self.pos[1] - camera.y ) > 550:
                self.deathClock += t
                if self.deathClock > 1000:
                    self.kill()
            else:
                self.deathClock = 0

        return False

    def DeathCheck( self ):
        damage = len( pygame.sprite.spritecollide( self, bulletGroup, True ) )
        self.health -= damage
        if self.health <= 0:
            self.kill()



class Spider( Living ):
    def __init__( self, pos ):
        Living.__init__( self, 10, 15, pos )
        self._images = spiderWalk
        self.image = spiderWalk[0]
        self.rect = pygame.Rect( pos, (64,64) )

        self.jumpVel = 0
        self.vert = 0

        if self.pos[0] < player.pos[0]:
            self.move = 4
        else:
            self.move = -4
        self.jumping = False

    def Jump( self ):
        if not self.jumping:
            self.jumpVel = -10
            self.jumping = True

    def update( self ):
        ticks = pygame.time.get_ticks()
        self.Tick( ticks )

        self.DeathCheck()

        self.pos[0] += self.move
        self.rect.topleft = ( self.pos[0] - camera.x, self.pos[1] - camera.y )
        col = pygame.sprite.spritecollide(self, levelGroup, False ) #: return Sprite_list
        if len(col):
            for c in col:
                # Left edge inside block, move right
                if c.pos[0] <= self.pos[0] and self.pos[0] < c.pos[0] + 64:
                    self.pos[0] = c.pos[0] + 64

                elif c.pos[0] <= self.pos[0]+64 and self.pos[0]+64 < c.pos[0] + 64:
                    self.pos[0] = c.pos[0] - 64

        if random.randrange(0,30) < 4:
            self.Jump()

        self.pos[1] += self.jumpVel
        self.rect.topleft = ( self.pos[0] - camera.x, self.pos[1] - camera.y )
        col = pygame.sprite.spritecollide(self, levelGroup, False )
        if len(col):
            for c in col:
                # up and down collision
                if c.pos[1] <= self.pos[1] and self.pos[1] < c.pos[1] + 64:
                    self.pos[1] = c.pos[1] + 64

                elif c.pos[1] <= self.pos[1]+64 and self.pos[1]+64 < c.pos[1] + 64:
                    self.pos[1] = c.pos[1] - 64
            self.jumpVel = 0
            self.jumping = False
        else:
            self.jumpVel += .6
            self.jumping = True


class Spawner( Living ):
    def __init__( self, pos, image ):
        Living.__init__( self, 250, 1, pos, True )
        self.image = image
        self._images = [image]
        self.rect = pygame.Rect( pos, (64,64) )

    # Spawn spiders instead of animating
    def update(self):

        self.DeathCheck()

        self.rect.topleft = ( self.pos[0] - camera.x, self.pos[1] - camera.y )

        if abs( self.pos[0] - player.pos[0] ) < 280 and abs( self.pos[1] - player.pos[1] ) < 280:
            if self.Tick( pygame.time.get_ticks() ):
                spiderGroup.add(  Spider( self.pos[:] ) ) # pass a copy otherwise the spawner moves with the spawned Enemy!


class Bullet( pygame.sprite.Sprite ):
    def __init__( self, img, pos,vel , angle ):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer
        self.image = pygame.transform.rotate( img, -angle )
        self.vel = vel
        self.rect = pygame.Rect( pos, (16,16) )
        self.pos = list(pos)


    def update( self ):
        self.pos[0] += self.vel[0]
        self.pos[1] += self.vel[1]

        self.rect.x = self.pos[0] - camera.x
        self.rect.y = self.pos[1] - camera.y

class Ground( pygame.sprite.Sprite ):
    def __init__( self, image, pos ):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer

        self.image = image
        self.pos = pos
        self.rect = pygame.Rect( pos, (64,64) )
        self.startRect = pygame.Rect( pos, (64,64) )
        self.newPos = (0,0)

    def draw( self ):
        self.newPos = ( self.rect.x - camera.x, self.rect.y - camera.y )
        #screen.blit( image, ( self.rect.x - camera.x, self.rect.y - camera.y ) )

    def update( self ):
        self.rect.topleft = ( self.startRect.x - camera.x, self.startRect.y - camera.y )




class Foliage( pygame.sprite.Sprite ):
    def __init__( self, image, pos ):
        pygame.sprite.Sprite.__init__(self) #call Sprite initializer

        self.image = image
        self.pos = pos
        self.rect = pygame.Rect( pos, (64,64) )
        self.startRect = pygame.Rect( pos, (64,64) )
        self.newPos = (0,0)

    def draw( self ):
        self.newPos = ( self.rect.x - camera.x, self.rect.y - camera.y )
        #screen.blit( image, ( self.rect.x - camera.x, self.rect.y - camera.y ) )

    def update( self ):
        self.rect.topleft = ( self.startRect.x - camera.x, self.startRect.y - camera.y )

'''

 moving/standing - air/ground - front/back - left/right

'''


class StateData:
    left = 1
    right = 1 << 1

    front = 1 << 2
    back = 1 << 3

    air = 1 << 4
    ground = 1 << 5

    moving = 1 << 6
    standing = 1 << 7

class State:
    runLeft = StateData.left | StateData.front | StateData.ground | StateData.moving
    idleLeft = StateData.left | StateData.front | StateData.ground | StateData.standing
    runRight = StateData.right | StateData.front | StateData.ground | StateData.moving
    idleRight = StateData.right | StateData.front | StateData.ground | StateData.standing

    airLeftForward = StateData.left | StateData.front | StateData.air | StateData.moving
    airLeftBack = StateData.left | StateData.back | StateData.air | StateData.moving
    airLeftIdle = StateData.left | StateData.front | StateData.air | StateData.standing

    airRightForward = StateData.right | StateData.front | StateData.air | StateData.moving
    airRightBack = StateData.right | StateData.back | StateData.air | StateData.moving
    airRightIdle = StateData.right | StateData.front | StateData.air | StateData.standing

class Player( Living ):

    def __init__(self):
        Living.__init__( self, 1000, 15, [0,0] )

        self.airborne = False
        self.runLeft = []
        self.runRight = []
        self.idleLeft = []
        self.idleRight = []
        self.airLeft = []
        self.airLeftBack = []
        self.airLeftDown = []
        self.airIdle = []
        self.airRight = []
        self.airRightBack = []
        self.airRightDown = []

        self.state = State.idleRight

        for i in range(9):
            self.runLeft.append( loadImage( "art/amytis/rs"+ str(i)+".bmp") )
            self.runRight.append( pygame.transform.flip(loadImage( "art/amytis/rs"+ str(i)+".bmp"),True, False) )

        for i in range(1,7):
            self.idleLeft.append( loadImage( "art/amytis/idle"+ str(i)+".bmp") )
            self.idleRight.append( pygame.transform.flip(loadImage( "art/amytis/idle"+ str(i)+".bmp"),True, False) )

        for i in range(10):
            self.airLeft.append( loadImage( "art/amytis/airLeft"+ str(i)+".png") )
            self.airRight.append( pygame.transform.flip(loadImage( "art/amytis/airLeft"+ str(i)+".png"),True, False) )

        for i in range(10):
            self.airLeftBack.append( loadImage( "art/amytis/airLeftBack"+ str(i)+".png") )
            self.airRightBack.append( pygame.transform.flip(loadImage( "art/amytis/airLeftBack"+ str(i)+".png"),True, False) )

        for i in range(10):
            self.airLeftDown.append( loadImage( "art/amytis/airDown"+ str(i)+".png") )
            self.airRightDown.append( pygame.transform.flip(loadImage( "art/amytis/airDown"+ str(i)+".png"),True, False) )


        self._images = self.idleRight

        self.image = self._images[0]
        self.rect = self.image.get_rect()
        #self.rect = pygame.Rect( (0,0), ( 32, 64 ) )
        self.velocity = 0
        self.vert = 0

        self.pos = [128,128]

        self.fire = True
        self.lFire = True

        self.falling = False
        self.fall_acc = 0


    def StickInput( self, key, up, down, left, right, fire, side, img ):
        angle = -1

        xSpeed = 0
        ySpeed = 0

        if controller and useJoystick:
            if side == "left":
                xSpeed = controller.GetLeftX()
                ySpeed = controller.GetLeftY()
            else:
                xSpeed = controller.GetRightX()
                ySpeed = controller.GetRightY()

            if abs(xSpeed) < 0.1 and abs(ySpeed) < 0.1:
                angle = -1
                xSpeed = 0
                ySpeed = 0
            else:
                angle =  math.degrees( math.atan2( ySpeed , xSpeed ) )
                if angle < 0:
                   angle += 360

        else:

            if key[ down ] and key[ left ]:
                angle = 135
            elif key[ down ] and key[ right ]:
                angle = 45
            elif key[ up ] and key[ right ]:
                angle = 315
            elif key[ up ] and key[ left ]:
                angle = 225

            elif key[ down ]:
                vert = -3
                angle = 90
            elif key[ up ]:
                vert = 4
                angle = 270
            elif key[ right ]:
                angle = 0
            elif key[ left ]:
                angle = 180

        # the arc* normalized the input
        if angle > -1:
            ySpeed = math.sin( math.radians(angle) )
            xSpeed = math.cos( math.radians(angle) )

            if fire:
                #bulletGroup.add( Bullet( (self.pos[0] + random.randrange(-7,7), self.pos[1] + random.randrange(-7,7)), (xSpeed*10, ySpeed*10), angle ) )
                startPos = ( self.pos[0]+20 + random.randrange(-7,7) + xSpeed*30,
                    self.pos[1] + 12 + random.randrange(-7,7) + ySpeed*30 )
                bulletGroup.add( Bullet( img, startPos , (xSpeed*10, ySpeed*10), angle ) )
                fire = False
            else:
                fire = True

        return angle, xSpeed, ySpeed


    def updatePos( self):


        key = pygame.key.get_pressed()
        '''
        velocity = 0
        if key[ K_a ]:
            velocity = -3
        elif key[ K_d ]:
            velocity = 3'''

        lAngle, lx, ly = self.StickInput( key, K_w, K_s, K_a, K_d, self.lFire, "left", bulletImage )
        direction = velocity = lx * 3

        vert = 4
        rAngle, rx, ry = self.StickInput( key, K_i, K_k, K_j, K_l, self.fire, "right", bulletImage2 )

        if -0.1 < rx and rx < 0.1:
            rx = 0

        if ry > 0.3:
            vert =  ry * -4
            velocity += rx * -2
        elif ry < -0.01:
            pass

        if 30 < rAngle and rAngle < 150:
            self.falling = False
            self.airborne = True
            self.fall_acc = 0
        elif 10 < rAngle and rAngle < 170:
            self.airborne = True
            self.fall_acc -= 1
            if self.fall_acc < 0:
                self.fall_acc = 0

        #self.pos = [ self.pos[0] + velocity, self.pos[1] + vert ]
        self.pos[0] += velocity
        self.rect.topleft = ( self.pos[0] - camera.x, self.pos[1] - camera.y )

        col = pygame.sprite.spritecollide(self, levelGroup, False ) #: return Sprite_list
        if len(col):
            for c in col:
                # Left edge inside block, move right
                if c.pos[0] <= self.pos[0] and self.pos[0] < c.pos[0] + 64:
                    self.pos[0] = c.pos[0] + 64

                elif c.pos[0] <= self.pos[0]+64 and self.pos[0]+64 < c.pos[0] + 64:
                    self.pos[0] = c.pos[0] - 64

        self.pos[1] += vert + self.fall_acc
        self.rect.topleft = ( self.pos[0] - camera.x, self.pos[1] - camera.y )

        col = pygame.sprite.spritecollide(self, levelGroup, False )
        if len(col):
            for c in col:
                # up and down collision
                if c.pos[1] <= self.pos[1] and self.pos[1] < c.pos[1] + 64:
                    self.pos[1] = c.pos[1] + 64

                elif c.pos[1] <= self.pos[1]+64 and self.pos[1]+64 < c.pos[1] + 64:
                    self.pos[1] = c.pos[1] - 64

                    self.airborne = False
                    self.falling = False
                    self.fall_acc = 0

        else:
            if vert > 0:
                # Increase falling speed till terminal velocity
                if self.falling:
                    self.fall_acc += .51
                    if self.fall_acc > 5:
                        self.fall_acc

                self.falling = True
                self.airborne = True

        # self.falling, self.airborne
        if not self.airborne:
            if direction < -1 and self.state!= State.runLeft:
                    self._images = self.runLeft
                    self.state = State.runLeft
                    self._frame = -1

            elif direction > 1 and self.state != State.runRight:
                self._images = self.runRight
                self.state = State.runRight
                self._frame = -1


            elif direction == 0:
                if not ( self.state & StateData.standing & StateData.ground ):
                    if self.state & StateData.left:
                        self._images = self.idleLeft
                        self.state = State.idleLeft
                        self._frame = -1
                    else:
                        self._images = self.idleRight
                        self.state = State.idleRight
                        self._frame = -1

        else:
            if direction < 0:

                if rx >= 0 and self.state != State.airLeftForward:
                    self._images = self.airLeft
                    self.state = State.airLeftForward
                    self._frame = -1

                elif rx < 0 and self.state != State.airLeftBack:
                    self._images = self.airLeftBack
                    self.state = State.airLeftBack
                    self._frame = -1

            elif direction > 0:

                if rx <= 0 and self.state != State.airRightForward:
                    self._images = self.airRight
                    self.state = State.airRightForward
                    self._frame = -1

                elif rx > 0 and self.state != State.airRightBack:
                    self._images = self.airRightBack
                    self.state = State.airRightBack
                    self._frame = -1

            elif direction == 0:

                if -.0001 < rx and rx < .0001:
                    if self.state & ( StateData.ground | StateData.moving ):
                        if self.state & StateData.left :
                            self._images = self.airLeftDown
                            self.state = State.airLeftIdle
                            self._frame = -1
                        else:
                            self._images = self.airRightDown
                            self.state = State.airRightIdle
                            self._frame = -1
                elif rx < 0:
                    if self.state & StateData.left:
                        self._images = self.airLeftBack
                        self.state = State.airLeftBack
                        self._frame = -1
                    else:
                        self._images = self.airRight
                        self.state = State.airRightForward
                        self._frame = -1
                else:
                    if self.state & StateData.left:
                        self._images = self.airLeft
                        self.state = State.airLeftForward
                        self._frame = -1
                    else:
                        self._images = self.airRightBack
                        self.state = State.airRightBack
                        self._frame = -1
    def update(self):
        self.Tick( pygame.time.get_ticks() )
        #self.rect.move_ip( velocity - camera.x, vert - camera.y )
        #self.pos = ( self.pos[0] + velocity, self.pos[1] + vert )
        self.rect.topleft = ( self.pos[0] - camera.x, self.pos[1] - camera.y )

        #pos = pygame.mouse.get_pos()
        #self.rect.midtop = pos

spawnerGroup = pygame.sprite.Group()

foliageGroup = pygame.sprite.Group()

class Level():
    def __init__( self, imagePath = "data/testLevel4.png" ):

        brick = loadImage( "art/inorganic/brick01.png", False )
        brickL = loadImage( "art/inorganic/brick01L.png" )
        brickR = loadImage2( "art/inorganic/brick01R.png", (63,0) )
        brickAngleL = loadImage2( "art/inorganic/brick01AngleL.png", (0,63) )
        brickAngleR = loadImage2( "art/inorganic/brick01AngleR.bmp", (63,63) )


        tree01 = loadImage( "art/tree01.png" )
        tree = loadImage( "art/tree.png" )

        self.levelData = []

        levelData = pygame.image.load( imagePath )
        for y in range( levelData.get_height() ):
            for x in range( levelData.get_width() ):
                color = levelData.get_at( (x,y) )
                if color[0] == 0:
                    self.levelData.append( Ground( brick, (x*64,y*64) ) )
                elif color[0] == 157:
                    player.pos = [x*64,y*64]
                elif color[0] == 47:
                    spawnerGroup.add( Spawner([x*64,y*64], mound ) )

                elif color[0] == 82:
                    self.levelData.append( Ground( brickAngleL, (x*64,y*64) ) )
                elif color[0] == 146:
                    self.levelData.append( Ground( brickAngleR, (x*64,y*64) ) )
                elif color[0] == 148:
                    self.levelData.append( Ground( brickL, (x*64,y*64) ) )
                elif color[0] == 73:
                    self.levelData.append( Ground( brickR, (x*64,y*64) ) )

                elif color[1] == 53:
                    foliageGroup.add( Foliage( tree, (x*64,y*64) ) )

                elif color[1] == 109:
                    foliageGroup.add( Foliage( tree01, (x*64,y*64) ) )



def input(events):
    global velocity
    global vert
    global useJoystick
    #velocity = 0
    for event in events:
        if event.type == QUIT:
            sys.exit(0)
        else:
            if event.type == 2:

                if event.dict['unicode'] == 'g':
                    if useJoystick:
                        useJoystick = False
                    else:
                        useJoystick = True

                # Left stick
                if event.dict['unicode'] == 'a':
                    velocity = -3
                elif event.dict['unicode'] == 'd':
                    velocity = 3
                elif event.dict['unicode'] == 'w':
                    vert = -3
                elif event.dict['unicode'] == 's':
                    vert = 3

                # Right stick
                if event.dict['unicode'] == 'j':
                    pass
                elif event.dict['unicode'] == 'l':
                    pass
                elif event.dict['unicode'] == 'i':
                    pass
                elif event.dict['unicode'] == 'k':
                    pass
            if event.type == 3:
                velocity = 0
                vert = 0

        #print event

pos = 35
velocity = 0
vert = 0

bg = loadImage( "art/sky.jpg", False)




screen = pygame.display.get_surface()

spiderGroup = pygame.sprite.Group()

player = Player()
level = Level()

#allsprites = pygame.sprite.RenderPlain( player, level.levelData )
playerGroup = pygame.sprite.GroupSingle( player )
levelGroup = pygame.sprite.Group( level.levelData )
bulletGroup = pygame.sprite.Group()


pygame.display.flip()

clock = pygame.time.Clock()

camera = pygame.Rect(64,64,0,0)

bulletImage = loadImage( "art/bullet.png")
bulletImage2 = loadImage( "art/bulletBlast.png")

controller = GameController.TwinSticks()

health = pygame.font.Font(None, 26)

class Game():

    def __init__( self ):
        self.mode = self.Title
        self.next = self.Calibration
        self.advance = K_RETURN
        self.axisCalibrate = -1

    def EnterToContinue( self, skip=False ):
        font = pygame.font.Font(None, 20)
        if skip:
            text = font.render("Press Enter To Skip", 1, (110, 110, 110))
        else:
            text = font.render("Press Enter", 1, (110, 110, 110))
        screen.blit(text, (200,500) )

    def Title( self,events ):

        screen.fill((0,0,0) )

        self.next = self.Calibration
        if pygame.font:
            font = pygame.font.Font(None, 36)
            text = font.render("Amytis Ascension", 1, (110, 110, 110))
            screen.blit(text, (100,100) )

        self.EnterToContinue()
        pygame.display.flip()

        self.advance = K_RETURN
        self.next = self.Story
        return True

    def Win( self,events ):

        screen.fill((0,0,250) )

        self.next = self.Calibration
        if pygame.font:
            font = pygame.font.Font(None, 36)
            text = font.render("You win!  Rad City!", 1, (255, 255, 255))
            screen.blit(text, (100,100) )
            self.EnterToContinue()

        pygame.display.flip()

        self.advance = K_RETURN
        self.next = self.Title
        return True

    def Story( self, events ):
        screen.fill( (0,0,0) )
        self.next = self.Calibration

        if pygame.font:
            font = pygame.font.Font(None, 36)

            story = [
            "King Nebuchadnezzar built the",
            "Hanging Gardens of Babylon",
            "for his homesick wife, Amytis...",
            "",
            "Until a space warrior from the",
            "future brought guns to fight off",
            "space bugs from invading the garden!"
            ]

            offset = 50
            for line in story:
                text = font.render( line, 1, (110, 110, 110))
                screen.blit(text, (50,offset) )
                offset += 40

        self.EnterToContinue()

        pygame.display.flip()
        self.advance = K_RETURN
        return True

    def Calibration( self, events ):
        global useJoystick
        if controller.calibrationLoaded:
            #pygame.event.post( pygame.event.Event( 2, {key:K_RETURN} ) )
            self.axisCalibrate = 4
            self.calibMessage = "Game Controller loaded"
            useJoystick = True


        screen.fill( (0,0,0) )
        self.next = self.Playing
        self.advance = K_RETURN

        if self.axisCalibrate == -1:
            self.calibMessage = "Press the Left Stick  <---"
            self.axisCalibrate += 1

        if pygame.font:
            font = pygame.font.Font(None, 26)
            text = font.render("Calibration", 1, (110, 110, 110))
            screen.blit(text, (50,50) )

            controls = [
                "W A S D / Left Stick = Move Left/Right Fire",
                "I J K L / Right Stick = Fire (can propel you!)",
                "G = Toggly Keyboard / Joystick control" ]

            offset = 100
            for c in controls:
                text = font.render( c, 1, (110, 110, 110))
                screen.blit(text, (50,offset) )
                offset += 45

            text = font.render(self.calibMessage, 1, (110, 110, 110))
            screen.blit(text, (50,350) )

        self.EnterToContinue( True )
        pygame.display.flip()

        if self.axisCalibrate == 0:
            if controller.Calibrate( GameController.Axis.LEFT_X ):
                self.axisCalibrate += 1
                self.calibMessage = "Press the Left Stick Up"

        elif self.axisCalibrate == 1:
            if controller.Calibrate( GameController.Axis.LEFT_Y ):
                self.axisCalibrate += 1
                self.calibMessage = "Press the Right Stick <--"

        elif self.axisCalibrate == 2:
            if controller.Calibrate( GameController.Axis.RIGHT_X ):
                self.axisCalibrate += 1
                self.calibMessage = "Press the Right Stick Up"

        elif self.axisCalibrate == 3:
            if controller.Calibrate( GameController.Axis.RIGHT_Y ):
                self.axisCalibrate += 1
                self.calibMessage = "Calibration Complete!"
                useJoystick = True
                controller.SaveCalibration()

        self.advance = K_RETURN
        return True

    def End(self, event):
        return False

    def Loop( self ):

        events = pygame.event.get()

        while( self.mode( events ) ):
            clock.tick(60)
            events = pygame.event.get()

            for event in events:
                if event.type == QUIT:
                    sys.exit(0)
                else:
                    if event.type == 2:
                        if event.key == self.advance:
                            self.mode = self.next
                            continue
                    elif event.type == 99:
                        self.mode = self.next
                        continue

    def Playing( self, events ):

        self.advance = K_p
        self.next = self.End

        input(events)
        player.updatePos()

        # Keep the player framed in the center
        if player.rect.x < 220:
            camera.move_ip( player.rect.x - 220, 0 )
        elif player.rect.x > 270:
            camera.move_ip( player.rect.x - 270, 0 )

        if player.rect.y < 220:
            camera.move_ip( 0, player.rect.y - 220 )
        elif player.rect.y > 270:
            camera.move_ip( 0, player.rect.y - 270 )

        foliageGroup.update()
        playerGroup.update()
        levelGroup.update()
        bulletGroup.update()
        spawnerGroup.update()
        spiderGroup.update()

        screen.fill((0,0,0) )

        screen.blit( bg, ( -100 - (camera.x/4.0), -100  - (camera.y/4.0)) )
        pygame.sprite.groupcollide( levelGroup, bulletGroup, False, True )


        # Remove bullets outside of the screen
        for bullet in bulletGroup.sprites():
            if bullet.pos[0] < camera.x or camera.x+512 < bullet.pos[0]:
                bulletGroup.remove(bullet )
            elif bullet.pos[1] < camera.y or camera.y +512 < bullet.pos[1]:
                bulletGroup.remove(bullet )

        foliageGroup.draw( screen )
        levelGroup.draw(screen)
        playerGroup.draw(screen)
        bulletGroup.draw( screen )
        spawnerGroup.draw( screen )
        spiderGroup.draw( screen )

        damage = len( pygame.sprite.spritecollide( player, spiderGroup, False ) )
        player.health -= damage


        # WIN!
        if len( spawnerGroup ) == 0:
            self.advance = None
            self.next = self.Win
            pygame.event.post( pygame.event.Event( 99, {K_RETURN:True}) )
            return True

        # DIED!
        if player.health <= 0:
            self.advance = None
            self.next = self.Title
            pygame.event.post( pygame.event.Event( 99, {K_RETURN:True}) )
            return True

        text = health.render( str(player.health) , 1, (255, 50, 50))
        screen.blit(text, (250,470) )

        pygame.display.flip()
        #pygame.display.update( playerRect )
        return True

game = Game()
game.Loop()